$(function() {
    let chapters = [];
    if ($('.chapters, .area_view h2, .area_view h3, .area_view h4').length > 0) {
        $('.chapters, .area_view h2, .area_view h3, .area_view h4').each(function(k, o) {
            $this = $(this);
            let text = $this.text();
            let depth = $this.data('chapters_depth');
            depth = typeof(depth) == 'undefined' ? 0 : depth;
            if (depth == 0) {
                if ($(this).prop('tagName') == 'h3') {
                    depth = 1;
                }
                if ($(this).prop('tagName') == 'h4') {
                    depth = 2;
                }
            }
            let padding_left = depth * 8;
            padding_left = padding_left == 0 ? 3 : padding_left;
            let css_indent = '';
            css_indent = " style='padding-left:" + padding_left + "px' ";
            let regExp = /[\{\}\[\]\/?.,;:|\)*~`!^\+<>@\#$%&\\\=\(\'\"]/gi; // 占쎈��붻눧紐꾩쁽 -占쏙옙 占쎌뮇��
            let text_esc = text.replace(/\&lt\;/g, '<').replace(/(\&gt\;)/g, '>');
            text_esc = text_esc.replace(/<[^>]+>/gm, '');
            text_esc = text_esc.replace(/\&nbsp\;/g, '_').replace(regExp, '').replace(/ /g, '_');
            text_esc = text_esc + '_' + k;
            $this.data('chapter-key', k);
            $target_anchor = $('<a name="' + text_esc + '" class="chapters-target"></a>');
            $this.before($target_anchor);
            depth = depth > 3 ? 3 : depth;
            $('#chapters_lists > dl').append("<dd ><a href='#" + text_esc + "' class='chapters-item chapters-item-depth-" + depth + "' " + css_indent + ">" + text + "</a></dl>");
            chapters.push($target_anchor);
        });
        $('#chapters_lists').addClass("chapters_lists_on");
        $('.area_title').after("<div class='area_chapters'>" + $('#chapters_lists').html() + "</div>");

        $(document).on("click", ".chapters-item", function() {
            $(this).parent().addClass('chapter-on-scroll');
            let chapter_anchor = $(this).prop("href").replace('#', '');
            $("#chapters_lists a[href='#" + chapter_anchor + "']").parent().addClass('chapter-on-scroll');
            $("#chapters_lists a").not("a[href='#" + chapter_anchor + "']").parent().removeClass('chapter-on-scroll');
        });

        $(window).scroll(function(event) {
            let scroll_y = $(this).scrollTop();
            let chapter_anchor;
            if (chapters.length == 0) {
                return;
            }
            for (k in chapters) {
                let chpt = $(chapters[k]);
                try {
                    if (scroll_y >= chpt.offset().top) {
                        chapter_anchor = chpt.prop("name");
                    }
                } catch (e) {
                    break;
                }
            }
            $("#chapters_lists a[href='#" + chapter_anchor + "']").parent().addClass('chapter-on-scroll');
            $("#chapters_lists a").not("a[href='#" + chapter_anchor + "']").parent().removeClass('chapter-on-scroll');
        });
    }



    if ($("pre[data-ke-type='codeblock']").length > 0) {
        $("pre[data-ke-type='codeblock']").each(function() {
            let pre_lang = $(this).data('ke-language').toUpperCase();
            pre_lang = pre_lang == 'SCALA' ? 'SHELL' : pre_lang;
            $(this).prepend("<span class='codeblock-lang'>" + pre_lang + "</span>");
        })
    }
});